## bladeRF-ddbe087df6742b0272f96a8f5225021577c72335.tar.gz

=== host/libraries/libbladeRF/CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)
project(libbladeRF C)

################################################################################
# Version information
################################################################################

set(VERSION_INFO_MAJOR  2)
set(VERSION_INFO_MINOR  0)
set(VERSION_INFO_PATCH  2)

if(NOT DEFINED VERSION_INFO_EXTRA)
    set(VERSION_INFO_EXTRA "git")
endif()
include(Version)

set(VERSION "${VERSION_INFO}")
set(LIBVER "${VERSION_INFO_BASE}")

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/version.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/version.h
    @ONLY
)

if(MSVC)
    configure_file(
        ${CMAKE_CURRENT_SOURCE_DIR}/bladerf.rc.in
        ${CMAKE_CURRENT_BINARY_DIR}/bladerf.rc
        @ONLY
    )
endif()

if (NOT CMAKE_INSTALL_LIBDIR)
include(GNUInstallDirs)
endif (NOT CMAKE_INSTALL_LIBDIR)

# Fall back to just "lib" if the item provided by GNUInstallDirs doesn't exist
# For example, on Ubuntu 13.10 with CMake 2.8.11.2,
# /usr/lib/${CMAKE_LIBRARY_ARCHITECTURE} doesn't exist.
if (NOT EXISTS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
    message(STATUS "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR} does not exist. Defaulting libbladeRF install location to ${CMAKE_INSTALL_PREFIX}/lib.")
    set(CMAKE_INSTALL_LIBDIR lib)
endif()

################################################################################
# Configuration options
################################################################################

option(ENABLE_LIBBLADERF_LOGGING "Enable log messages in libbladeRF." ON)

option(ENABLE_LIBBLADERF_SYSLOG "Enable logging to syslog (Linux/OSX)" OFF)

option(BUILD_LIBBLADERF_DOCUMENTATION "Build libbladeRF documentation. Requries Doxygen." ${BUILD_DOCUMENTATION})
if(NOT ${BUILD_DOCUMENTATION})
    set(BUILD_LIBBLADERF_DOCUMENTATION OFF)
endif()

option(BUILD_LIBBLADERF_DOC_EXAMPLES "Compile examples that are included in Doxygen documentation (mainly for QA purposes)." ${BUILD_LIBBLADERF_DOCUMENTATION})

option(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE
      "Enable log_verbose() calls in the sync interface's data path. Note that this may harm performance."
      OFF
)

option(ENABLE_LOCK_CHECKS
       "Enable checks for lock acquisition failures (e.g., deadlock)"
       OFF
)

option(ENABLE_USB_DEV_RESET_ON_OPEN
       "Perform a USB port reset when opening a device. This works around an issue on some Linux USB 3.0 setups that prevents a device from being opened after an application crash or unclean exit."
       ${BLADERF_OS_LINUX}
)

option(ENABLE_RFIC_TIMING_CALIBRATION
       "Perform timing calibration on the RFIC digital interface during initialization. This is only implemented on AD936x-based hardware."
       OFF
)

##############################
# Backend Support
##############################
option(ENABLE_BACKEND_USB
    "Enable USB backends. Required when using the bladeRF with a host machine."
    ON
)

option(ENABLE_BACKEND_LIBUSB
    "Enable libusb backend support."
    ${LIBUSB_FOUND}
)

option(ENABLE_BACKEND_CYAPI
    "Enable CYAPI backend support."
    ${CYAPI_FOUND}
)

option(ENABLE_BACKEND_DUMMY
    "Enable dummy backend support. This is only useful for some developers."
    OFF
)

# Ensure we've got at least one backend enabled
if(NOT ENABLE_BACKEND_LIBUSB
   AND NOT ENABLE_BACKEND_LINUX_DRIVER
   AND NOT ENABLE_BACKEND_CYAPI
   AND NOT ENABLE_BACKEND_DUMMY)
    message(FATAL_ERROR
            "No libbladeRF backends are enabled. "
            "Please enable one or more backends." )
endif()

configure_file(
    ${CMAKE_CURRENT_SOURCE_DIR}/src/backend/backend_config.h.in
    ${CMAKE_CURRENT_BINARY_DIR}/src/backend/backend_config.h
    @ONLY
)

################################################################################
# Additional compiler options
################################################################################
if(ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DLOGGING_ENABLED)
endif()

if(ENABLE_LIBBLADERF_SYSLOG)
    add_definitions(-DLOG_SYSLOG_ENABLED)
endif()

if(ENABLE_LOCK_CHECKS)
    add_definitions(-DENABLE_LOCK_CHECKS)
endif()

if(ENABLE_RFIC_TIMING_CALIBRATION)
    add_definitions(-DENABLE_AD9361_DIGITAL_INTERFACE_TIMING_VERIFICATION)
endif()

if(${CMAKE_C_COMPILER_ID} STREQUAL "GNU" OR
   ${CMAKE_C_COMPILER_ID} STREQUAL "Clang")

    # Doing this manually instead of via add_compiler_export_flags() since
    # the GenerateExportHeader module appears to break for C-only projects:
    #
    # http://www.cmake.org/pipermail/cmake-commits/2012-August/013142.html
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -fvisibility=hidden")
endif()

# We define LIBBLADERF_SEARCH_PREFIX to specify where libbladeRF should look
# for files, such as FPGA bitstreams to autoload.
#
# This defaults to the value of ${CMAKE_INSTALL_PREFIX}. However,
# users may wish to override when cross compiling.
if(LIBBLADERF_SEARCH_PREFIX_OVERRIDE)
    add_definitions(-DLIBBLADERF_SEARCH_PREFIX="${LIBBLADERF_SEARCH_PREFIX_OVERRIDE}")
else()
    add_definitions(-DLIBBLADERF_SEARCH_PREFIX="${CMAKE_INSTALL_PREFIX}")
endif()



################################################################################
# Include paths
################################################################################
set(LIBBLADERF_INCLUDES
    ${CMAKE_CURRENT_SOURCE_DIR}/include
    ${CMAKE_CURRENT_SOURCE_DIR}/src
    ${BLADERF_HOST_COMMON_INCLUDE_DIRS}
    ${BLADERF_FW_COMMON_INCLUDE_DIR}
    ${BLADERF_FPGA_COMMON_INCLUDE_DIR}
    ${CMAKE_CURRENT_BINARY_DIR}/src
)



################################################################################
# Build dependencies
################################################################################
if(MSVC)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${MSVC_C99_INCLUDES})

    find_package(LibPThreadsWin32 REQUIRED)
    if(LIBPTHREADSWIN32_FOUND)
        set(HAVE_THREADS true)
        set(LIBBLADERF_INCLUDES
            ${LIBBLADERF_INCLUDES} ${LIBPTHREADSWIN32_INCLUDE_DIRS})
        set(LIBBLADERF_LIBS
            ${LIBBLADERF_LIBS} ${LIBPTHREADSWIN32_LIBRARIES})
    else()
        set(HAVE_THREADS false)
    endif()
else(MSVC)
    find_package(Threads REQUIRED)
    if(Threads_FOUND)
        set(HAVE_THREADS true)
    else()
        set(HAVE_THREADS false)
    endif()
endif(MSVC)

if(BLADERF_OS_OSX)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} /usr/include/malloc)
endif()

if (NOT HAVE_THREADS)
    message(FATAL_ERROR "pthreads not found. This is required to build libbladeRF.")
endif()

if(NOT ENABLE_BACKEND_USB)
    set(ENABLE_BACKEND_LIBUSB OFF)
    set(ENABLE_BACKEND_LINUX_DRIVER OFF)
endif()

if(ENABLE_BACKEND_LIBUSB)
    if(NOT LIBUSB_FOUND)
        message(FATAL_ERROR "libusb-1.0 not found. This is required to use the libbladeRF libusb backend. For binary releases, try setting LIBUSB_PATH.")
    else(NOT LIBUSB_FOUND)
        if(LIBUSB_VERSION)
            if(NOT LIBUSB_VERSION VERSION_LESS "1.0.10")
                add_definitions(-DHAVE_LIBUSB_GET_VERSION)
            endif()

            if(WIN32)
                # We require v1.0.19 because it provides Windows 8 USB 3.0
                # speed detection fixes, additional AMD/Intel USB 3.0 root
                # hub support, and some fixes to issues reported on v1.0.18
                # that yielded corrupted samples.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.19")
                    message(FATAL_ERROR "libusb v1.0.19 is required in Windows.\n"
                                        "Please update libusb or consider using the Cypress backend if this is not possible.\n"
                                        "Detected version: ${LIBUSB_VERSION}\n")
                endif()
            elseif(APPLE)
                # A number of important changes were included in libusb
                # v1.0.16 hrough v1.0.18, including SuperSpeed support, 64-bit support,
                # and various build and crash fixes.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.18")
                    message(FATAL_ERROR "libusb v1.0.18 is required in OS X. Please update libusb."
                                        "Detected version: ${LIBUSB_VERSION}\n")
                endif()
            elseif(UNIX)
                # A number of reported issues supposedly became resolved after
                # updating to >= 1.0.16.
                if(${LIBUSB_VERSION} VERSION_LESS "1.0.16")
                    message(WARNING "\nlibusb >= 1.0.16 is HIGHLY recommended. "
                                    "If you experience issues or poor performance, please try updating libusb.\n"
                                    "Detected version: ${LIBUSB_VERSION}")
                endif()
            else()
                message(WARNING "Unexpected system type. Please report this warning to developers.")
            endif()
        elseif(BLADERF_OS_FREEBSD)
            message(STATUS "Using FreeBSD's built-in libusb implementation.")
        else()
            message(WARNING "Not checking libbladeRF/libusb compatibility because LIBUSB_VERSION is not defined.")
        endif()
        set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${LIBUSB_INCLUDE_DIRS})
    endif(NOT LIBUSB_FOUND)
endif(ENABLE_BACKEND_LIBUSB)

if(ENABLE_BACKEND_CYAPI)
    find_package(CyAPI REQUIRED)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES} ${CYAPI_INCLUDE_DIRS})
endif(ENABLE_BACKEND_CYAPI)

if(MSVC)
    set(LIBBLADERF_INCLUDES ${LIBBLADERF_INCLUDES}
        ${LIBPTHREADSWIN32_INCLUDE_DIRS})
endif()

if(ENABLE_LIBBLADERF_SYNC_LOG_VERBOSE AND ENABLE_LIBBLADERF_LOGGING)
    add_definitions(-DENABLE_LIBBLADERF_SYNC_LOG_VERBOSE)
endif()

if(ENABLE_USB_DEV_RESET_ON_OPEN)
    add_definitions(-DENABLE_USB_DEV_RESET_ON_OPEN=1)
endif()

include_directories(${LIBBLADERF_INCLUDES})

################################################################################
# Configure source files
################################################################################
set(LIBBLADERF_AD9361_SOURCE
        src/driver/thirdparty/adi/ad9361.c
        src/driver/thirdparty/adi/ad9361_api.c
        src/driver/thirdparty/adi/ad9361_conv.c
        src/driver/thirdparty/adi/adc_core.c
        src/driver/thirdparty/adi/dac_core.c
        src/driver/thirdparty/adi/util.c
        src/driver/thirdparty/adi/platform.c
)

if(NOT MSVC)
    set_source_files_properties(${LIBBLADERF_AD9361_SOURCE} PROPERTIES COMPILE_FLAGS "-std=gnu11")
endif(NOT MSVC)

set(LIBBLADERF_SOURCE
        src/backend/backend.c
        src/driver/spi_flash.c
        src/driver/fx3_fw.c
        src/driver/fpga_trigger.c
        src/driver/si5338.c
        src/driver/ina219.c
        src/driver/dac161s055.c
        src/driver/smb_clock.c
        src/board/bladerf1/bladerf1.c
        src/board/bladerf1/capabilities.c
        src/board/bladerf1/compatibility.c
        src/board/bladerf1/calibration.c
        src/board/bladerf1/flash.c
        src/board/bladerf1/image.c
        src/board/bladerf2/bladerf2.c
        src/board/bladerf2/capabilities.c
        src/board/bladerf2/compatibility.c
        src/board/bladerf2/params.c
        src/board/board.c
        src/expansion/xb100.c
        src/expansion/xb200.c
        src/expansion/xb300.c
        src/streaming/async.c
        src/streaming/sync.c
        src/streaming/sync_worker.c
        src/init_fini.c
        src/helpers/timeout.c
        src/helpers/file.c
        src/helpers/version.c
        src/helpers/wallclock.c
        src/helpers/interleave.c
        src/helpers/configfile.c
        src/version.h
        src/devinfo.c
        src/bladerf.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/sha256.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/conversions.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/log.c
        ${BLADERF_FPGA_COMMON_SOURCE_DIR}/lms.c
        ${BLADERF_FPGA_COMMON_SOURCE_DIR}/band_select.c
        ${BLADERF_HOST_COMMON_SOURCE_DIR}/parse.c
        ${LIBBLADERF_AD9361_SOURCE}
)

if (MSVC)

=== debian/control ===
Source: bladerf
Priority: optional
Maintainer: Rey Tucker <rey.tucker@nuand.com>
Build-Depends: debhelper (>=9), cmake (>= 2.8.5), pkg-config, doxygen,
 libusb-1.0-0-dev (>= 1.0.12), libtecla-dev | libtecla1-dev, libncurses5-dev,
 git, help2man, pandoc
Standards-Version: 4.1.4
Section: comm
Homepage: https://www.nuand.com/bladeRF
Vcs-Git: git://github.com/Nuand/bladeRF.git
Vcs-Browser: https://github.com/Nuand/bladeRF

Package: libbladerf2
Section: libs
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}, libusb-1.0-0 (>= 1.0.12)
Recommends: bladerf-fpga, libbladerf-udev
Suggests: bladerf-firmware
Description: Nuand bladeRF software-defined radio device
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides the host library.

Package: libbladerf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libbladerf2 (= ${binary:Version}), libc6-dev | libc-dev, ${misc:Depends}
Description: Nuand bladeRF software-defined radio device (header files)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains the header files required for compiling bladeRF
 applications.

Package: libbladerf-udev
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}, udev
Conflicts: libbladerf0
Description: Nuand bladeRF software-defined radio device (header files)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package contains udev rules to ensure that the USB device is
 configured correctly when connected.

Package: bladerf
Section: comm
Architecture: any
Multi-Arch: foreign
Depends: libbladerf2 (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}, libbladerf-udev
Provides: bladerf-host
Conflicts: bladerf-host
Replaces: bladerf-host
Description: Nuand bladeRF software-defined radio device (tools)
 The Nuand bladeRF is an open-source software-defined radio (SDR) system,
 comprised of an RF transceiver, a field-programmable gate array (FPGA),
 a microcontroller driving a USB 3.0 interface, and a suite of host
 libraries and drivers to facilitate interaction with the device.
 .
 This package provides command-line tools for controlling the bladeRF.

Package: bladerf-fpga-hostedx40
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedx40)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF x40 with the Altera Cyclone IV
 EP4CE40 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedx115
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedx115)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF x115 with the Altera Cyclone IV
 EP4CE115 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedxa4
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedxA4)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF 2.0 Micro xA4 with the Altera Cyclone V
 5CEBA4 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-fpga-hostedxa9
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-firmware
Provides: bladerf-fpga
Description: Nuand bladeRF FPGA bitstream downloader (hostedxA9)
 This package will, at the time of installation, download an appropriate
 FPGA bitstream for using the Nuand bladeRF in a hosted (USB-controlled)
 configuration.  The FPGA bitstream will be downloaded from
 https://nuand.com/fpga/ and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream is for the bladeRF 2.0 Micro xA9 with the Altera Cyclone V
 5CEBA9 FPGA.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.

Package: bladerf-firmware-fx3
Section: comm
Architecture: any
Depends: wget, ${shlibs:Depends}, ${misc:Depends}
Recommends: bladerf
Suggests: bladerf-fpga
Provides: bladerf-firmware
Description: Nuand bladeRF firmware downloader (FX3)
 This package will, at the time of installation, download an appropriate
 firmware image for using the Nuand bladeRF with a Cypress FX3 USB
 controller.  The image will be downloaded from https://nuand.com/fx3/
 and saved to /usr/share/Nuand/bladeRF.
 .
 This bitstream will work for either the Nuand bladeRF x40 or the x115,
 as well as the bladeRF 2.0 Micro xA4 or xA9.
 .
 Note that this will not upgrade the bladeRF itself.  That can be done
 with the bladeRF-cli utility.
